/* KEYTEST2.C
 *
 * By Gary Neal, Jr. -- garyneal@mailcity.com
 * http://www.geocities.com/SiliconValley/Park/7113/
 *
 * Tests the low level keyboard handler while chained to BIOS.
 */

#include <conio.h>      /* Console output */
#include "keyboard.h"   /* Low level keyboard functions */
#include "boolean.h"    /* Definition for 'bool' */

int main(void)
{
    int c = '\0';

    cputs("Keyboard ISR with BIOS handler enabled example.\r\n");
    cputs("\r\nType something, anything...\r\n");
    cputs("Press CTRL-Z when finished...\r\n");
    cputs("    ...or hard abort with CTRL-ALT-DEL or CTRL-ALT-ESC.\r\n\r\n");

    /* Install Low Level Keyboard Handler *
     * Chain the BIOS system.             *
     * Do use a callback function.        */
    InstallKeyboardHandler(true, 0);

    /* Continue until CTRL-Z is pressed. */
    while (c != 26) {
        while (!KeyHardAbort() && !kbhit());  /* Wait for a key press. */
        if (KeyHardAbort()) break;            /* Break if hard abort */
        c = getch();                          /* Read the key */
        putch(c);                             /* Output character */
        if (c == '\r') putch('\n');           /* Write newline for ENTER */
    }

    /* Write newline character. */
    putch('\r');
    putch('\n');

    /* Remove the low level keyboard handler. */
    RemoveKeyboardHandler();

    /* Display status information. */
    if (KeyHardAbort())
        puts("Exiting due to a hard abort.");
    else
        puts("EOF character encountered, exiting....");

    return 0;
}
