/* KEYTEST3.CPP
 *
 * By Gary Neal, Jr. -- garyneal@mailcity.com
 * http://www.geocities.com/SiliconValley/Park/7113/
 *
 * This program uses the C++ extensions of the keyboard functions.
 *
 * Mainly all they do is allow default parameters to the
 * InstallKeyboardHandler function.
 */

#include <dos.h>          // For low level dos functions.
#include <stdio.h>        // For fputs functions.
#include "keyboard.h"     // Low level keyboard functions.

// Segment pointer (Borland only)
unsigned char _seg *VIDEO_SEG = (unsigned char _seg *)0xA000;

int main(void)
{
    int X, Y;             // X and Y pixel location.
    union REGS regs;      // Register variable structure.

    regs.x.ax = 0x0013;   // Specify video mode 13h.
    int86(0x10, &regs, &regs);
    regs.h.ah = 0x0F;     // Check if mode was changed.
    int86(0x10, &regs, &regs);
    if (regs.h.al != 0x13) {
        fputs("VGA 320 x 200 x 256 not supported", stderr);
        return 1;
    }

    // Set start pixel location.
    X = 160;
    Y = 100;

    // Install the low level keyboard handler using default parameters.
    InstallKeyboardHandler();

    // Continue until ESC was pressed or a hard abort was encountered.
    while (!KeyPressed(KEY_ESC) && !KeyHardAbort()) {
        /* What a piece of crap!  The pokeb function does not work
           properly in a C++ program using Turbo C++.
        pokeb(40960, Y * 320 + X, 0);    // Erase pixel.
        */
        VIDEO_SEG[Y * 320 + X] = 0;

        // Move pixel according to key being pressed.
        if (KeyPressed(KEY_UP)) {
            if (--Y < 0) Y = 0;
        } else if (KeyPressed(KEY_DOWN)) {
            if (++Y > 199) Y = 199;
        }

        if (KeyPressed(KEY_LEFT)) {
            if (--X < 0) X = 0;
        } else if (KeyPressed(KEY_RIGHT)) {
            if (++X > 319) X = 319;
        }

        /* pokeb(40960, Y * 320 + X, 15);   // Redraw pixel. */
        VIDEO_SEG[Y * 320 + X] = 15;
        delay(10);                       // 10ms delay (Borland only)
    }

    // Remove the low level keyboard handler.
    RemoveKeyboardHandler();

    // Restore text mode.
    regs.x.ax = 0x0003;
    int86(0x10, &regs, &regs);

    return 0;
}
