/* KEYTEST5.C
 *
 * By Gary Neal, Jr. -- garyneal@mailcity.com
 * http://www.geocities.com/SiliconValley/Park/7113/
 *
 * This functions uses a primitive buffer to display keyboard scan codes
 * as the keyboard is being pressed.
 */

#include <stdio.h>
#include "keyboard.h"
#include "boolean.h"

#define BUFFER_SIZE 1024
volatile unsigned char myBuffer[BUFFER_SIZE];
volatile int currCharPosition = 0;
volatile int firstCharPosition = 0;

void far UpdateBuffer(void)
{
    myBuffer[currCharPosition] = inp(0x60);
    ++currCharPosition;
    currCharPosition %= BUFFER_SIZE;
}

int main(void)
{
    int count_out = 0;

    puts("Press some keys, their scan codes will be listed as you type.");
    puts("Press CTRL-ALT-ESC to quit.\n");

    InstallKeyboardHandler(false, UpdateBuffer);

    while(!KeyHardAbort()) {
        while (firstCharPosition != currCharPosition) {
            printf("0x%X ", myBuffer[firstCharPosition++]);
            firstCharPosition %= BUFFER_SIZE;

            count_out = ++count_out & 7;
            if (!count_out)
                putchar('\n');
        }
    }

    RemoveKeyboardHandler();
    return 0;
}
