/* KEYTEST6.C
 *
 * By Gary Neal, Jr. -- garyneal@mailcity.com
 * http://www.geocities.com/SiliconValley/Park/7113/
 *
 * Tests the low level keyboard handler for validity and stability.
 */

#include <stdio.h>
#include <conio.h>
#include <stdlib.h>
#include "keyboard.h"
#include "boolean.h"

int main(void)
{
    int key_state;

    atexit(RemoveKeyboardHandler);

    puts("Installing the low level keyboard handler with BIOS support.");
    puts("Type anything and press ENTER.\n");

    InstallKeyboardHandler(true, NULL);
    while (kbhit()) getch();
    while (getche() != '\r')
        if (KeyHardAbort())
            exit(1);

    key_state = KeyPressed(KEY_ENTER);
    printf("You are pressing ");

    if (key_state == 0x81)
        puts("both ENTER keys.");
    else if (key_state & 0x80)
        puts("the ENTER key on the numeric keypad.");
    else if (key_state & 0x01)
        puts("the ENTER key on the standard keyboard.");

    puts("\nTaking exclusive control of the keyboard.");
    puts("Press one of the ENTER keys.  Press ESC to finish.\n");
    while (kbhit()) getch();
    InstallKeyboardHandler(false, NULL);

    while (!KeyPressed(KEY_ESC)) {
        key_state = KeyPressed(KEY_ENTER);
        if (key_state == 0x81)
            puts("Both ENTER keys are pressed.");
        else if (key_state & 0x80)
            puts("The ENTER key on the numeric keypad is pressed.");
        else if (key_state & 0x01)
            puts("The ENTER key on the standard keyboard is pressed.");

        if (KeyHardAbort())
            exit(1);
    }

    puts("\nRemoving the low level keyboard handler twice.");
    RemoveKeyboardHandler();
    RemoveKeyboardHandler();

    puts("...and one more for the road.");
    return 0;
}

